﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Common;
using System.Data.Objects;
using System.Data;
using System.Reflection;

namespace DomainModel
{
    public partial class AcmeWidgets
    {
        public void DeleteAll()
        {
            DbConnection connection = base.Connection;

            DbCommand cmd = connection.CreateCommand();
            cmd.CommandText = "AcmeWidgets.DeleteAll";
            cmd.CommandType = System.Data.CommandType.StoredProcedure;

            connection.Open();
            cmd.ExecuteNonQuery();
            connection.Close();
        }

        
        public void DeleteOrder(Order order)
        {
            if (order.OrderItems.IsLoaded == false)
            {
                order.OrderItems.Load();

            }

            foreach (OrderItem item in order.OrderItems.ToList())
            {
                DeleteObject(item);
            }

            DeleteObject(order.Version);
            DeleteObject(order);
        }

public void Submit()
{
    // Establish all the entities that have changed
    //
    var entities = this.ObjectStateManager
        .GetObjectStateEntries(EntityState.Modified | EntityState.Added );

    var toIncrement = new Dictionary<int, SharedVersion>();

    // Foreach entity that has changed, if it has a shared version
    // then increment it.
    foreach (ObjectStateEntry attachedObject in entities.Where(e => e.IsRelationship == false ) )
    {
        // If No property of type SharedVersion then it will not attempt to increment the version
        // if many it will throw an exception
        // if just one will increment the version number, assuming it has not 
        // previously been incremented
        PropertyInfo versionProperty = (from prop in attachedObject.Entity.GetType().GetProperties()
                                        where prop.PropertyType == typeof(SharedVersion)
                                        select prop)
                                        .DefaultIfEmpty(null)
                                        .Single();

        if (versionProperty != null)
        {
            SharedVersion versionEntity = (SharedVersion) versionProperty.GetValue(attachedObject.Entity, null);

            if (versionEntity != null)
            {

                if (!toIncrement.ContainsKey(versionEntity.id))
                {
                    toIncrement.Add(versionEntity.id, versionEntity);
                    versionEntity.Increment();
                }

            }
            else
            {
                throw new SharedVersionException("You must load the version of the entity if you wish to modify it");
            }
        }     
    }

    // Now call down to the entity framework to do persist
    // any version entities used will now be marked.
    SaveChanges();
}
    }
}
