﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DomainModel;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Tests
{
    public static class Util
    {
        public static void TestInitialise()
        {
            using (AcmeWidgets ctx = new AcmeWidgets())
            {
                ctx.DeleteAll();

                // Confirm no orders
                Assert.IsTrue(ctx.OrderSet.Count() == 0);

                CreateProducts();



            }


        }

        private static void CreateProducts()
        {
            using (AcmeWidgets ctx = new AcmeWidgets())
            {
                Product thingOne = new Product()
                {
                    Title = "Thing One",
                    Description = "Primary Thing",
                    Price = 10.2m,
                    SalesTax = 0.175m,
                };

                Product thingTwo = new Product()
                {
                    Title = "Thing Two",
                    Description = "Primary Thing",
                    Price = 10.2m,
                    SalesTax = 0.175m,
                };

                ctx.AddToProductSet(thingOne);
                ctx.AddToProductSet(thingTwo);

                ctx.SaveChanges();

                Assert.IsTrue(ctx.ProductSet.Count() == 2);
            }
        }

        public static void CreateEmptyOrder()
        {
            using (AcmeWidgets ctx = new AcmeWidgets())
            {
                Customer customer = new Customer()
                {
                    Name = "Andy",
                    City = "Chippenham",
                    Street = "High Street",
                    Zip = "SN11 1XH",
                };


                Order order = new Order()
                {
                    Customers = customer,
                    Shipped = false,
                    Version = new SharedVersion(),
                };

                ctx.AddToOrderSet(order);
                ctx.SaveChanges();
            }
        }
      
    }
}
